﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Jailbreak
{
    /// <summary>
    /// Interaction logic for MainUserControl.xaml
    /// </summary>
    public partial class MainUserControl : UserControl
    {
        public MainUserControl()
        {
            InitializeComponent();
            initialize_game();
            show_room();
            szActionDescription = string.Empty;
            textBox1.Focus();
        }

        protected override void OnRender(DrawingContext drawingContext)
        {
            base.OnRender(drawingContext);
            DrawContents(drawingContext);
        }

        string szRoomDescription;
        string szActionDescription;
        void trim_action_text()
        {
	        while (szActionDescription.Length > 1024)
	        {
                int index = szActionDescription.IndexOf ('\n');
		        if (index == -1)
			        return;
                szActionDescription = szActionDescription.Substring (index + 1);
	        }
        }

        void initialize_game()
        {
            p = new place[]
            {
	            new place ("", 0, 0, 0, 0),
	            new place ("a jail cell", 0, 0, 0, 0),
                new place ("a long narrow hallway", 5, 3, 0, 1),
                new place ("an office", 2,0,0,0),
                new place ("the arms room", 0, 0, 0, 3),
                new place ("the north end of the hallway", 0, 2, 6, 0),
                new place ("the round room", 0, 0, 0, 5),
                new place ("an \"L\"-shaped room", 0, 8, 0, 6),
                new place ("the warden's office", 7, 9, 0, 0),
                new place ("the exit", 8, 0, 0, 0),
                new place ("front of the prison", 11, 12, 13, 9),
                new place ("a courthouse", 0, 10, 0, 0),
                new place ("a general store", 10, 0, 0, 0),
                new place ("an open field", 0, 0, 0, 10)
            };

            ob = new adventure_object[]
            {
	            new adventure_object ("", 0),
	            new adventure_object ("Locked door facing east", 1),
	            new adventure_object ("=Security guard=", 1),
	            new adventure_object ("Set of keys", 0),
	            new adventure_object ("Roll of money", 3),
	            new adventure_object ("Loaded revolver", 4),
	            new adventure_object ("Empty revolver", 0),
	            new adventure_object ("Disguise kit", 6),
	            new adventure_object ("Badge", 7),
	            new adventure_object ("=Warden=", 8),
	            new adventure_object ("Salesman with a shovel", 12),
	            new adventure_object ("Salesman with some money", 0),
	            new adventure_object ("* Evidence *", 0),
	            new adventure_object ("Judge", 11),
	            new adventure_object ("Dead guard", 0),
	            new adventure_object ("Open wall facing east", 0),
	            new adventure_object ("Shovel", 0)
            };

            cp = 1;
            disguised = false;
            wearingBadge = false;
            hintsDisplayed = 0;
        }

        void show_room()
        {
	        string [] dir = new string[]
	        {
		        "North", "South", "East", "West"
	        };

	        szRoomDescription = "You are in " + p[cp].name + ".";
	        bool foundOne = false;
            int charColumn = 0;
            for (int i = 1; i < ob.Length; ++i)
		        if (ob[i].room == cp)
		        {
			        if (!foundOne)
			        {
				        szRoomDescription += "  Visible items:\n\n";
                        foundOne = true;
			        }
                    if (ob[i].name.Length + charColumn > 77)
                    {
                        szRoomDescription += "\n";
                        charColumn = 0;
                    }
                    szRoomDescription += ob[i].name + ".  ";
                    charColumn += ob[i].name.Length + 3;
                };
	        foundOne = false;
	        for (int i = 0; i <= 3; ++i)
		        if (p[cp].exit[i] != 0)
		        {
			        if (!foundOne)
			        {
				        szRoomDescription += "\n\nObvious exits:";
				        foundOne = true;
			        }
			        szRoomDescription += " " + dir[i];
		        }
            if (ob[9].room == cp  &&  (!wearingBadge  ||  !disguised))
            {
                szActionDescription += "The warden recognizes you!\n";
                adventure_over();
            }
        }

        void DrawContents(DrawingContext dc)
        {
            Point upperLeftCornerOfTextBox = textBox1.TranslatePoint(new Point(0, 0), this);

            FormattedText ft = new FormattedText(szActionDescription,
                System.Globalization.CultureInfo.CurrentCulture, System.Windows.FlowDirection.LeftToRight,
                new Typeface("Verdana"), 12, System.Windows.Media.Brushes.Black);
            dc.DrawText (ft, new Point(5, upperLeftCornerOfTextBox.Y - ft.Height - 5));

            ft = new FormattedText(szRoomDescription,
                System.Globalization.CultureInfo.CurrentCulture, System.Windows.FlowDirection.LeftToRight,
                new Typeface("Verdana"), 12, Brushes.Black);
            dc.DrawRectangle (Brushes.White, null, new Rect (0, 0, 2000, ft.Height + 12));
            dc.DrawText(ft, new Point(5, 5));
            dc.DrawLine (new Pen (Brushes.Black, 1), new Point (0, ft.Height + 10),
                         new Point (2000, ft.Height + 10));
            
            if (textBox1.Visibility == System.Windows.Visibility.Visible)
            {
                ft = new FormattedText ("  ------> What now? ",
                    System.Globalization.CultureInfo.CurrentCulture, System.Windows.FlowDirection.LeftToRight,
                    new Typeface("Verdana"), 12, System.Windows.Media.Brushes.Black);
                dc.DrawText (ft, new Point (5, upperLeftCornerOfTextBox.Y + 4));
            }
        }

        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Enter)
            {
                // The user pressed enter.  Process the command.
                string szCommand = textBox1.Text;
                int verb;
				NounType noun;
                if (input_command (szCommand, out verb, out noun))
                    do_command(verb, noun);
                textBox1.Text = string.Empty;
				trim_action_text();
                InvalidateVisual();
            }
        }


        struct place
        {
	        public string name;
	        public int [] exit;    // 6 exits, one for each direction
            public place (string theName, int north, int south, int east, int west)
            {
                exit = new int[4];
                name = theName;
                exit[0] = north;
                exit[1] = south;
                exit[2] = east;
                exit[3] = west;
            }
        };
        place[] p;

        struct adventure_object
        {
	        public string name;
	        public int room;    // if room == 14, it's in your inventory
            public adventure_object (string theName, int startingRoom)
            {
                name = theName;
                room = startingRoom;
            }
        };
        adventure_object[] ob;

        int cp; // the Current Place in the adventure
        bool wearingBadge;
        bool disguised;
        int hintsDisplayed;
        
        string verb_str, noun_str;
        enum NounType
        {
            none,
            GUAR,
            KEYS,
            MONE,
            REVO, GUN,
            KIT,
            BADG,
            WARD,
            DOOR,
            SHOV,   // 10
            JUDG,
            SALE, CLER,
            EVID,
            VOIC,
            BUTT,
            DISG,
            last
        }

        private bool input_command (string szCommand, out int verb, out NounType noun)
        {
	        string [] verb_table = new string[]
	        {
		        "",
		        "GET", "TAKE",
		        "DROP", "RELE",
		        "OPEN", "UNLO",
		        "CLOS", "SHUT", "LOCK",
                "FIRE",
                "SHOO",
                "WEAR",
                "SHOW",
                "THRO",
		        "KILL",
		        "DIG",
		        "BUY",
		        "FRIS",
		        "PRES", "PUSH",
                "SEAR",
		        "PUT",
		        "GIVE",
		        "DISG",
		        "N", "S", "E", "W",
		        "INVE", "I",
		        "LOOK", "L",
                ".",
		        "HELP",
		        "QUIT",
		        "P"
	        };
	        string [] noun_table = new string[]
	        {
		        "",
		        "GUAR",
		        "KEYS",
		        "MONE",
		        "REVO", "GUN",
		        "KIT",
		        "BADG",
		        "WARD",
		        "DOOR",
		        "SHOV",
		        "JUDG",
		        "SALE", "CLER",
                "EVID",
		        "VOIC",
		        "BUTT",
		        "DISG"
	        };
            verb = 0;
            noun = NounType.none;

	        verb_str = string.Empty;
	        noun_str = string.Empty;

	        szActionDescription += "  ------> What now? " + szCommand + "\n";
	        int i = 0;
	        while (i < szCommand.Length  &&  szCommand[i] != ' ')
		        ++i;
	        verb_str = szCommand.Substring (0, i);
	        if (i < 30)
	        {
		        int j = i;
		        while (j < szCommand.Length  &&  szCommand[j] == ' ')
			        ++ j;
		        if (j < szCommand.Length)
			        noun_str = szCommand.Substring (j);
	        }
            string verbStrToCompare = verb_str;
            if (verbStrToCompare.Length > 4)
                verbStrToCompare = verbStrToCompare.Substring (0,4);
            verbStrToCompare = verbStrToCompare.ToUpper();
            i = 1;
            while (i < verb_table.Length && verbStrToCompare != verb_table[i])
		        ++i;
            if (i < verb_table.Length)
		        verb = i;
	        else
	        {
		        szActionDescription += "I don't know how to \"" + verb_str + "\" something.\n";
		        return false;
	        }
	        if (noun_str != string.Empty)
	        {
                string nounStrToCompare = noun_str;
                if (nounStrToCompare.Length > 4)
                    nounStrToCompare = nounStrToCompare.Substring(0, 4);
                nounStrToCompare = nounStrToCompare.ToUpper();
                NounType n = NounType.none;
                ++n;
                while (n < NounType.last && nounStrToCompare != noun_table[(int)n])
                    ++n;
                if (n < NounType.last)
                    noun = n;
                else
                {
                    szActionDescription += "I don't know what \"" + noun_str + "\" is.\n";
                    return false;
                }
            }
            return true;
        }

        // Master verb function chooser, derived from BASIC on-goto statement.
        private void do_command(int verb, NounType noun)
        {
            switch (verb)
            {
                case 1:
                case 2:
                    verb_take(noun);
                    break;
                case 3:
                case 4:
                    verb_drop(noun);
                    break;
                case 5:
                case 6:
                    verb_open(noun);
                    break;
                case 7:
                case 8:
                case 9:
                    verb_close(noun);
                    break;
                case 10:
                    verb_fire (noun);
                    break;
                case 11:
                    verb_shoot (noun);
                    break;
                case 12:
                    verb_wear(noun);
                    break;
                case 13:
                    verb_show (noun);
                    break;
                case 14:
                    verb_throw (noun);
                    break;
                case 15:
                    verb_kill();
                    break;
                case 16:
                    verb_dig();
                    break;
                case 17:
                    verb_buy(noun);
                    break;
                case 18:
                    verb_frisk (noun);
                    break;
                case 19:
                case 20:
                    verb_press(noun);
                    break;
                case 21:
                    verb_search (noun);
                    break;
                case 22:
                    verb_wear(noun);
                    break;
                case 23:
                    verb_show(noun);
                    break;
                case 24:
                    verb_wear(noun);
                    break;
                case 25:
                    move_dir(0);
                    break;
                case 26:
                    move_dir(1);
                    break;
                case 27:
                    move_dir(2);
                    break;
                case 28:
                    move_dir(3);
                    break;
                case 29:
                case 30:
                    verb_inventory();
                    break;
                case 31:
                case 32:
                    verb_look(noun);
                    break;
                case 33:
                    verb_take(noun);
                    break;
                case 34:
                    verb_help();
                    break;
                case 35:
                    verb_show(noun);
                    break;
                case 36:
                    verb_quit();
                    break;
                case 37:
                    verb_drop (noun);
                    break;
            }
            show_room();
        }

        private void move_dir(int direc)
        {
	        if (p[cp].exit[direc] == 0)
		        szActionDescription += "There is no way to go that direction.\n";
            else if (direc == 2  &&  ob[2].room == cp)
                szActionDescription += "The guard will not let you pass!\n";
            else
	        {
    		    cp = p[cp].exit[direc];
		        szActionDescription += "Ok\n";
	        }
        }

        private void verb_what()
        {
            szActionDescription += verb_str + " what?\n";
        }

        private int MapNounToObject (NounType noun, int room)
        {
            switch (noun)
            {
                case NounType.GUAR:
                    if (ob[14].room == room)
                        return 14;
                    else
                        return 2;
                case NounType.KEYS:
                    return 3;
                case NounType.MONE:
                    return 4;
                case NounType.REVO:
                case NounType.GUN:
                    if (ob[6].room == room)
                        return 6;
                    else
                        return 5;
                case NounType.KIT:
                    return 7;
                case NounType.BADG:
                    return 8;
                case NounType.WARD:
                    return 9;
                case NounType.DOOR:
                    return 1;
                case NounType.SHOV:
                    return 16;
                case NounType.JUDG:
                    return 13;
                case NounType.SALE:
                case NounType.CLER:
                    if (ob[11].room == room)
                        return 11;
                    else
                        return 10;
                case NounType.EVID:
                    return 12;
                case NounType.DISG:
                    return 7;
                default:
                    return 0;
            }
        }

        private void verb_take (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun == NounType.BUTT)
                szActionDescription += "Sorry, wrong type button.\n";
            else if (noun == NounType.GUAR  ||
                     noun == NounType.WARD  ||
                     noun == NounType.DOOR  ||
                     noun == NounType.JUDG  ||
                     noun == NounType.SALE  ||
                     noun == NounType.CLER  ||
                     noun == NounType.VOIC)
                szActionDescription += "It's beyond your power to do that.\n";
            else
            {
                int numItemsCarried = 0;
                for (int i = 1; i <= 16; ++i)
                    if (ob[i].room == 14)
                        ++ numItemsCarried;
                if (numItemsCarried > 6)
                    szActionDescription += "You are currently holding too much. Try: TAKE INVENTORY\n";
                else
                {
                    int o = MapNounToObject (noun, cp);
                    if (ob[o].room != cp)
                        szActionDescription += "You don't see it here.\n";
                    else
                    {
                        szActionDescription += "Ok\n";
                        ob[o].room = 14;
                    }
                }
            }
        }

        private void verb_drop(NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else
            {
                int o = MapNounToObject(noun, 14);
                if (ob[o].room != 14)
                    szActionDescription += "You aren't holding it.\n";
                else
                {
                    szActionDescription += "Ok\n";
                    ob[o].room = cp;
                    if (o == 8)
                        wearingBadge = false;
                    else if (o == 7)
                        disguised = false;
                }
            }
        }

        private void verb_open(NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.DOOR)
                szActionDescription += "There is no keyhole in a \"" + noun_str + "\"!\n";
            else if (ob[1].room != cp)
                szActionDescription += "You don't see it here.\n";
            else if (ob[3].room != 14)
                szActionDescription += "You have no keys!\n";
            else
            {
                szActionDescription += "The door is now unlocked, offering passage to the east.\n";
                if (cp == 1)
                {
                    p[1].exit[2] = 2;
                    ob[1].room = 9;
                }
                else
                {
                    p[9].exit[2] = 10;
                    ob[1].room = 0;
                }
            }
        }

        private void verb_close (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.DOOR)
                szActionDescription += "There is no keyhole in a \"" + noun_str + "\"!\n";
            else if (ob[1].room != cp)
                szActionDescription += "You don't see it here.\n";
            else
                szActionDescription += "It's already closed and locked.\n";
        }

        private void verb_fire (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.REVO  &&  noun != NounType.GUN)
                szActionDescription += "You can't fire a \"" + noun_str + "\"!\n";
            else
                szActionDescription += "Try: SHOOT something.\n";   // You can't get ye flask
        }

        private void verb_shoot (NounType noun)
        {
            if (ob[6].room == 14)
                szActionDescription += "Your gun is empty!\n";
            else if (ob[5].room != 14)
                szActionDescription += "You don't have a gun to shoot!\n";
            else
            {
                szActionDescription += "You fire the revolver...\n";
                InvalidateVisual();
                textBox1.Visibility = System.Windows.Visibility.Hidden;
                System.Threading.Thread.Sleep (1500);
                textBox1.Visibility = System.Windows.Visibility.Visible;
                ob[5].room = 0;
                ob[6].room = 14;
                if (ob[2].room != cp)
                    szActionDescription += "It has no effect!\n";
                else
                {
                    szActionDescription += "The guard, unprepared for the attack, dies.\n";
                    ob[2].room = 0;
                    ob[14].room = cp;
                }
            }
        }

        private void verb_wear (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            if (noun == NounType.KIT  ||  noun == NounType.DISG)
                if (ob[7].room != 14)
                    szActionDescription += "You aren't holding it.\n";
                else if (disguised)
                    szActionDescription += "You are already wearing it.\n";
                else
                {
                    szActionDescription += "Ok\n";
                    disguised = true;
                }
            else if (noun != NounType.BADG)
                szActionDescription += "You can't wear a \"" + noun_str + "\"!\n";
            else if (ob[8].room != 14)
                szActionDescription += "You aren't holding it.\n";
            else if (wearingBadge)
                szActionDescription += "You are already wearing it.\n";
            else
            {
                szActionDescription += "Ok\n";
                wearingBadge = true;
            }
        }

        private void verb_show (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.EVID)
                szActionDescription += "That is one thing that can't be shown.\n";
            else if (ob[12].room != 14)
                szActionDescription += "You aren't holding it.\n";
            else if (ob[13].room != cp)
                szActionDescription += "Nothing special happens.\n";
            else
            {
                szActionDescription += "The judge sees the evidence, and finds you innocent!!\n";
                // Never mind the prison guard you had to kill in cold blood to get to this point,
                // or the judicial procedures required to overturn a felony conviction when new
                // evidence is uncovered....
                adventure_over();
            }
        }

        private void verb_throw (NounType noun)
        {
            if (noun != NounType.VOIC)
                verb_drop(noun);
            else if (cp != 1  ||  ob[2].room != cp)
                szActionDescription += "Nothing special happens.\n";
            else
            {
                szActionDescription += "The guard, hearing the sound, runs to the north.\n"
                    + "In doing so, he drops his keys.\n";
                // Gotta love the airtight security around this prison....
                ob[2].room = 5;
                ob[3].room = cp;
            }
        }

        private void verb_kill()
        {
            szActionDescription += "Be more specific as to how.\n";
        }

        private void verb_dig()
        {
            if (ob[16].room != 14)
                szActionDescription += "You have nothing to dig with!\n";
            else if (cp != 13  ||  ob[12].room != 0)
                szActionDescription += "You found nothing special.\n";
            else
            {
                szActionDescription += "You found a piece of evidence!\n";
                ob[12].room = cp;
            }
        }

        private void verb_buy (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.SHOV)
                szActionDescription += "You can't buy a \"" + noun_str + "\"!\n";
            else if (ob[11].room == cp)
                szActionDescription += "Sorry, that was the last one.  They're all out of stock.\n";
            else if (ob[10].room != cp)
                szActionDescription += "There is no one here to sell anything!\n";
            else if (ob[4].room != 14)
                szActionDescription += "You have nothing to buy it with!\n";
            else
            {
                szActionDescription += "Ok\n";
                ob[10].room = 0;
                ob[11].room = cp;
                ob[4].room = 0;
                ob[16].room = 14;
            }
        }

        private void verb_frisk (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.GUAR)
                szActionDescription += "Nothing on that!\n";
            else if (ob[2].room == cp)
                szActionDescription += "The guard won't let you.\n";
            else if (ob[14].room != cp)
                szActionDescription += "You don't see it here.\n";
            else
                szActionDescription += "There is a small button on his belt.\n";
        }

        private void verb_press (NounType noun)
        {
            if (noun == NounType.none)
                verb_what();
            else if (noun != NounType.BUTT)
                szActionDescription += "You can't press a \"" + noun_str + "\"!\n";
            else if (ob[14].room != cp)
                szActionDescription += "No button here!\n";
            else if (ob[15].room != 0)
                szActionDescription += "Nothing special happens.\n";
            else
            {
                szActionDescription += "You hear a small whir from the east.\n";
                ob[15].room = 6;
                p[6].exit[2] = 7;
            }
        }

        private void verb_search (NounType noun)
        {
            if (cp != 3  ||  p[3].exit[2] == 4)
            {
                szActionDescription += "You found nothing special.\n";
                if (cp > 9)
                    szActionDescription += "Maybe you should try digging.\n";
                else if (ob[14].room == cp  &&  noun == NounType.GUAR)
                    szActionDescription += "Maybe you should frisk him.\n";
            }
            else
            {
                szActionDescription += "You found an eastbound secret passage.\n";
                p[3].exit[2] = 4;
            }
        }

        private void verb_inventory()
        {
            szActionDescription += "You are currently holding the following:\n";
            bool foundOne = false;
            int charColumn = 0;
            for (int i = 0; i < ob.Length; ++i)
                if (ob[i].room == 14)
                {
                    foundOne = true;
                    if (ob[i].name.Length + charColumn > 77)
                    {
                        szActionDescription += "\n";
                        charColumn = 0;
                    }
                    szActionDescription += ob[i].name + ".  ";
                    charColumn += ob[i].name.Length + 3;
                }
            if (!foundOne)
                szActionDescription += "Nothing at all";
            szActionDescription += "\n";
            if (disguised)
                szActionDescription += "(You're disguised in the kit)\n";
            if (wearingBadge)
                szActionDescription += "(You're wearing the badge)\n";
        }

        private void verb_look (NounType noun)
        {
            if (ob[1].room != cp  &&  p[3].exit[2] == 0)
                szActionDescription += "Search and ye shall find.\n";
            else
                szActionDescription += "Sorry, I can only describe what you see.\n";
        }

        private void verb_help()
        {
            ++ hintsDisplayed;
            if (hintsDisplayed == 1)
                szActionDescription += "The hint is \"sound.\"\n";
            else if (hintsDisplayed == 2)
                szActionDescription += "The hint is \"ventriloquism.\"\n";
            else
                szActionDescription += "No more hints, sorry.\n";
        }

        private void verb_quit()
        {
            adventure_over();
        }

        internal void verb_save()
        {
            Microsoft.Win32.SaveFileDialog dlg = new Microsoft.Win32.SaveFileDialog();
            dlg.DefaultExt = ".sav";
            dlg.Filter = "Save files (.sav)|*.sav";
            bool? result = dlg.ShowDialog();
            if (result != null  &&  result == true)
            {
                string filename = dlg.FileName;
                StreamWriter f;
                try
                {
                    f = new StreamWriter(filename);
                }
                catch (Exception ex)
                {
                    szActionDescription += "Error creating file \"" + filename + "\":\n" + ex.Message + "\n";
                    return;
                }

                for (int i = 0; i < ob.Length; ++i)
                    f.WriteLine(ob[i].room);
                f.WriteLine(p[1].exit[2]);
                f.WriteLine(p[3].exit[2]);
                f.WriteLine(p[6].exit[2]);
                f.WriteLine(p[9].exit[2]);
                f.WriteLine(cp);
                f.WriteLine(wearingBadge);
                f.WriteLine(disguised);
                f.WriteLine(hintsDisplayed);
                f.Flush();
                f.Close();
            }
        }

        internal void LoadGame()
        {
            verb_load();
            show_room();
            InvalidateVisual();
        }

        private void verb_load()
        {
            Microsoft.Win32.OpenFileDialog dlg = new Microsoft.Win32.OpenFileDialog();
            dlg.DefaultExt = ".sav";
            dlg.Filter = "Save files (.sav)|*.sav";
            bool? result = dlg.ShowDialog();
            if (result != null && result == true)
            {
                string filename = dlg.FileName;
                StreamReader fs;
                try
                {
                    fs = new StreamReader(filename);
                }
                catch (Exception ex)
                {
                    szActionDescription += "Could not open \"" + filename + "\":\n" + ex.Message + "\n";
                    return;
                }

                try
                {
                    string s;
                    for (int i = 0; i < ob.Length; ++i)
                    {
                        s = fs.ReadLine();
                        ob[i].room = int.Parse (s);
                    }
                    s = fs.ReadLine();
                    p[1].exit[2] = int.Parse (s);
                    s = fs.ReadLine();
                    p[3].exit[2] = int.Parse(s);
                    s = fs.ReadLine();
                    p[6].exit[2] = int.Parse(s);
                    s = fs.ReadLine();
                    p[9].exit[2] = int.Parse(s);
                    s = fs.ReadLine();
                    cp = int.Parse(s);
                    s = fs.ReadLine();
                    wearingBadge = bool.Parse(s);
                    s = fs.ReadLine();
                    disguised = bool.Parse(s);
                    s = fs.ReadLine();
                    hintsDisplayed = int.Parse(s);
                    fs.Close();
                }
                catch (Exception ex)
                {
                    szActionDescription += "Error reading \"" + filename + "\":\n" + ex.Message + "\n";
                    // The game is now in a hopelessly mangled state.  Better give up.
                    adventure_over();
                    return;
                }

            }
        }

        private void adventure_over()
        {
            textBox1.Visibility = System.Windows.Visibility.Hidden;
            // TODO: gray out the "save game" option.
            szActionDescription += "\n\nThe adventure has ended.\n\n";
        }
    }
}
